using System;
using System.Collections.Generic;
using System.Linq;
using System.Xml.Linq;
using Avalonia.Controls;
using AvaloniaApplication4.Models;
using AvaloniaApplication4.Views;
using DynamicData.Kernel;
using Microsoft.EntityFrameworkCore;
using ReactiveUI;

namespace AvaloniaApplication4.ViewModels
{
	public class AccountPageViewModel : ViewModelBase
	{
		private UsersLogin? userLogin;
        private string? newPassword;
        private string? newPasswordAgain;
        private string? login;
        private bool isChange = false;
        private List<UsersLogin>? allLogins;

        private string message = "";
        private bool error = false;

        public bool IsChange
        {
            get { return isChange; }
            set
            {
                if (isChange == value)
                    return;

                isChange = value;
                OnPropertyChanged("IsChange");
            }
        }
        public string Message
        {
            get { return message; }
            set
            {
                if (message == value)
                    return;

                message = value;
                OnPropertyChanged("Message");
            }
        }

        public string? NewPassword { get => newPassword; set => newPassword = value; }
        public string? NewPasswordAgain { get => newPasswordAgain; set => newPasswordAgain = value; }
        public UsersLogin? UserLogin { get => userLogin; set => userLogin = value; }
        public string? Login { get => login; set => login = value; }

        public AccountPageViewModel(User user)
        {
            allLogins = dataBase.UsersLogins.ToList();
            UserLogin = dataBase.UsersLogins.Include(x => x.IdUserNavigation).FirstOrDefault(x => x.IdUser == user.IdUser);
            allLogins.Remove(UserLogin);
        }
        public AccountPageViewModel()
        {

        }
        public void SaveChanges()
        {
            if (UserLogin.IdUserNavigation.Name != "" && UserLogin.IdUserNavigation.Surname != "" && UserLogin.IdUserNavigation.Name != null && UserLogin.IdUserNavigation.Surname != null)
            {
                if (isChange)
                {
                    if (NewPassword == NewPasswordAgain && NewPassword != null && NewPassword != "" && Login != null && Login != "" && Login == UserLogin.UserEmail)
                    {
                        UserLogin.Password = NewPassword;
                    }
                    else
                    {
                        Message = "  ";
                        error = true;
                    }
                }
            }
            else
            {
                Message = "    ";
                error = true;
            }
            if (!error)
            {
                dataBase.SaveChanges();
                Message = "";
                WriteToLog(UserLogin.IdUser, "()  ");
                Window message = new MessageBox("  ");
                message.Show();
            }
        }
    }
}