using System;
using System.Collections.Generic;
using System.Linq;
using AvaloniaApplication4.AdditionalModels;
using AvaloniaApplication4.Models;
using AvaloniaApplication4.Views;
using AvaloniaApplication4.Views.ActionPages;
using Microsoft.EntityFrameworkCore;
using ReactiveUI;

namespace AvaloniaApplication4.ViewModels
{
    public class AllEmployeesViewModel : ViewModelBase
    {
        GlobalsData globalsData;
        User? user;
        List<User> allUsers;
        List<User> allUsersStatic;
        string search = string.Empty;
        public AllEmployeesViewModel(GlobalsData globalsData, User? user)
        {
            this.globalsData = globalsData;
            this.user = user;
            allUsers = dataBase.Users.ToList();
            allUsersStatic = allUsers;
        }
        public string Search
        {
            get { return search; }
            set
            {
                search = value;
                if (search != null && search != string.Empty)
                {
                    AllUsers = allUsersStatic.Where(x=>x.Name.ToLower().StartsWith(search.ToLower()) 
                    || x.Surname.ToLower().StartsWith(search.ToLower()) 
                    || x.Patronumic.ToLower().StartsWith(search.ToLower())).ToList();
                }
                else
                {
                    AllUsers = allUsersStatic;
                }
            }
        }

        public List<User> AllUsers
        {
            get { return allUsers; }
            set
            {
                if (allUsers == value)
                    return;
                allUsers = value;
                OnPropertyChanged("AllUsers");
            }
        }
        public void AddUser()
        {
            globalsData.GlobalUserControl = new EditAndAddEmployee(user, ref globalsData);
        }
        public void EditUser(int idUser)
        {
            var employee = dataBase.Users.FirstOrDefault(x=>x.IdUser ==  idUser);
            if (employee != null)
            {
                globalsData.GlobalUserControl = new EditAndAddEmployee(user, ref globalsData,employee);
            }
        }
    }
}