﻿using AvaloniaApplication4.AdditionalModels;
using AvaloniaApplication4.Models;
using AvaloniaApplication4.Views.ActionPages;
using AvaloniaApplication4.Views.StudyLists;
using Microsoft.EntityFrameworkCore;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Reactive.Subjects;
using System.Text;
using System.Threading.Tasks;
using static AvaloniaApplication4.ViewModels.StudyListsViewModels.DiffCreditViewModel;

namespace AvaloniaApplication4.ViewModels
{
    public class BindingElement: ViewModelBase
    {
        User? user;
        GlobalsData globalsData;
        StudyListSubjectsStudent grade;
        List<Grade> allGradesInBase;
        List<StudyListSubjectsStudent> allGrade;
        int idGradle;
        List<Statistic> statistics;
        Models.ProgramsWithSubject subject;
        int idAction;

        public BindingElement(User? user, StudyListSubjectsStudent grade, List<StudyListSubjectsStudent> allGrade, ProgramsWithSubject subject,GlobalsData globalsData, int idAction)
        {
            this.globalsData = globalsData;
            this.idAction = idAction;
            this.user = user;
            this.grade = grade;
            this.subject = subject;
            if (grade.Grade != null)
            {
                idGradle = (int)grade.Grade;
            }
            else idGradle = 0;
            allGradesInBase = dataBase.Grades.ToList();
            allGradesInBase.Add(new Models.Grade() { Id = 0, Name = "Не выбрано" });
            allGradesInBase = allGradesInBase.OrderBy(x => x.Id).ToList();
            this.allGrade = allGrade;
            statistics = new List<Statistic>();
            Update();
        }

        public StudyListSubjectsStudent Grade
        {
            get { return grade; }
            set
            {
                if (grade == value)
                    return;
                grade = value;
                OnPropertyChanged("Grade");
            }
        }
        public int IdGradle
        {
            get { return idGradle; }
            set
            {
                if (idGradle == value)
                    return;
                idGradle = value;
                var obj = dataBase.StudyListSubjectsStudents.FirstOrDefault(x => x.IdStudent == Grade.IdStudent && x.IdSubject == Grade.IdSubject);
                if (obj != null)
                {
                    if (idGradle > 0)
                    {
                        Grade.Grade = idGradle;
                        obj.Grade = idGradle;
                    }
                    else
                    {
                        Grade.Grade = null;
                        obj.Grade = null;
                    }
                    dataBase.SaveChanges();
                    string message = "изменил(а) данные в ведомости по предмету: " + Grade.IdSubjectNavigation.NameSubject;
                    WriteToLog(user.IdUser, message);
                }
                Update();
                globalsData.GlobalUserControl = new DiffCredit(user, ref globalsData,subject,idAction);
                OnPropertyChanged("IdGradle");
            }
        }
        public List<Grade> AllGradesInBase { get => allGradesInBase; set => allGradesInBase = value; }
        public class Statistic
        {
            int countStudents;
            int countAtt;
            int countGrade5;
            int countGrade4;
            int countGrade3;
            int countGrade2;
            int countNotAtt;
            int countNotCome;
            public Statistic(int countStudents, int countAtt, int countGrade5, int countGrade4, int countGrade3, int countGrade2, int countNotAtt, int countNotCome)
            {
                this.countStudents = countStudents;
                this.countAtt = countAtt;
                this.countGrade5 = countGrade5;
                this.countGrade4 = countGrade4;
                this.countGrade3 = countGrade3;
                this.countGrade2 = countGrade2;
                this.countNotAtt = countNotAtt;
                this.countNotCome = countNotCome;
            }
            public int CountStudents { get => countStudents; set => countStudents = value; }
            public int CountAtt { get => countAtt; set => countAtt = value; }
            public int CountGrade5 { get => countGrade5; set => countGrade5 = value; }
            public int CountGrade4 { get => countGrade4; set => countGrade4 = value; }
            public int CountGrade3 { get => countGrade3; set => countGrade3 = value; }
            public int CountGrade2 { get => countGrade2; set => countGrade2 = value; }
            public int CountNotAtt { get => countNotAtt; set => countNotAtt = value; }
            public int CountNotCome { get => countNotCome; set => countNotCome = value; }
        }
        public void Update()
        {
            allGrade = dataBase.StudyListSubjectsStudents.Include(x => x.IdStudentNavigation)
                .Include(x => x.IdSubjectNavigation)
                .Include(x => x.GradeNavigation)
                .Where(x => x.IdSubject == subject.IdSubject)
                .ToList();
            int countStudents = 0;
            int countAtt = 0;
            int countGrade5 = 0;
            int countGrade4 = 0;
            int countGrade3 = 0;
            int countGrade2 = 0;
            int countNotAtt = 0;
            int countNotCome = 0;
            foreach (var item in allGrade)
            {
                countStudents += 1;
                if (item.Grade != null)
                {
                    if (item.GradeNavigation.Name == "5")
                    {
                        countGrade5 += 1;
                        countAtt += 1;
                    }
                    if (item.GradeNavigation.Name == "4")
                    {
                        countGrade4 += 1;
                        countAtt += 1;
                    }
                    if (item.GradeNavigation.Name == "3")
                    {
                        countGrade3 += 1;
                        countAtt += 1;
                    }
                    if (item.GradeNavigation.Name == "2")
                    {
                        countGrade2 += 1;
                        countNotAtt += 1;
                    }
                    if (item.GradeNavigation.Name == "н/я")
                    {
                        countNotCome += 1;
                        countNotAtt += 1;
                    }
                    if (item.GradeNavigation.Name == "н/а")
                    {
                        countNotAtt += 1;
                    }
                }
                else countNotAtt += 1;
            }
            List<Statistic> temp = new List<Statistic>
            {
                new Statistic(countStudents, countAtt, countGrade5, countGrade4, countGrade3, countGrade2, countNotAtt, countNotCome)
            };
            Statistics = temp;
        }
        public List<Statistic> Statistics
        {
            get { return statistics; }
            set
            {
                if (statistics == value)
                    return;
                statistics = value;
                OnPropertyChanged("Statistics");
            }
        }
    }
}
