using System;
using System.Collections.Generic;
using System.Linq;
using AvaloniaApplication4.AdditionalModels;
using AvaloniaApplication4.Models;
using AvaloniaApplication4.Views.ActionPages;
using Microsoft.EntityFrameworkCore;
using ReactiveUI;

namespace AvaloniaApplication4.ViewModels
{
	public class EditAndAddEmployeeViewModel : ViewModelBase
	{
        GlobalsData globalsData;
        User? user;
        User employee;
        UsersLogin? employeeLogin;

        List<UsersWithRole> usersWithRoles;

        bool isAdmin = false;
        bool isTutor = false;
        bool isNotNew = true;

        public EditAndAddEmployeeViewModel(GlobalsData globalsData, User? user)
        {
            this.globalsData = globalsData;
            this.user = user;
            employee = new User();
            employeeLogin = new UsersLogin();

            usersWithRoles = new List<UsersWithRole>();
            isNotNew = false;
        }

        public EditAndAddEmployeeViewModel(GlobalsData globalsData, User? user, User employee)
        {
            this.globalsData = globalsData;
            this.user = user;
            this.employee = employee;
            employeeLogin = dataBase.UsersLogins.FirstOrDefault(x => x.IdUser == employee.IdUser);

            usersWithRoles = dataBase.UsersWithRoles.Include(x => x.IdRoleNavigation).Where(x => x.IdUser == employee.IdUser).ToList();
            foreach (var x in usersWithRoles)
            {
                if (x.IdRoleNavigation.RoleName == "") isAdmin = true;
                if (x.IdRoleNavigation.RoleName == "  ") isTutor = true;
            }
        }

        public User Employee { get => employee; set => employee = value; }
        public UsersLogin? EmployeeLogin { get => employeeLogin; set => employeeLogin = value; }

        public List<UsersWithRole> UsersWithRoles { get => usersWithRoles; set => usersWithRoles = value; }
        public bool IsAdmin { get => isAdmin; set => isAdmin = value; }
        public bool IsTutor { get => isTutor; set => isTutor = value; }
        public bool IsNotNew { get => isNotNew; set => isNotNew = value; }

        public void SaveChanges()
        {
            List<UsersLogin> all = dataBase.UsersLogins.ToList();
            bool isContains = false;
            User? tempUser = dataBase.Users.FirstOrDefault(x => x.IdUser == Employee.IdUser);
            //         ,    
            if (tempUser != null)
            {
                UsersLogin? tempUserLogins = dataBase.UsersLogins.FirstOrDefault(x => x.IdUser == tempUser.IdUser);
                if (tempUserLogins != null)
                {
                    all.Remove(tempUserLogins);
                }
            }
            foreach (var user in all)
            {
                if (user.UserEmail == EmployeeLogin.UserEmail) isContains = true;
            }
            // 
            if (Employee.Name != string.Empty && Employee.Surname != string.Empty && Employee.Patronumic != string.Empty && EmployeeLogin.UserEmail != string.Empty && EmployeeLogin.Password != string.Empty)
            {
                if (!isNotNew)
                {
                    if (!isContains)
                    {
                        dataBase.Users.Add(Employee);
                        var temp = dataBase.Users.OrderBy(x=>x.IdUser).Last();
                        EmployeeLogin.IdUser = temp.IdUser;
                        dataBase.UsersLogins.Add(EmployeeLogin);
                        SystemRole currentRole;
                        if (IsAdmin)
                        {
                            currentRole = dataBase.SystemRoles.FirstOrDefault(x => x.RoleName == "");
                            UsersWithRole newRole = new UsersWithRole() { IdRole = currentRole.IdRole, IdUser = Employee.IdUser };
                            dataBase.UsersWithRoles.Add(newRole);
                        }
                        if (IsTutor)
                        {
                            currentRole = dataBase.SystemRoles.FirstOrDefault(x => x.RoleName == "  ");
                            UsersWithRole newRole = new UsersWithRole() { IdRole = currentRole.IdRole, IdUser = Employee.IdUser };
                            dataBase.UsersWithRoles.Add(newRole);
                        }
                    }
                }
                else
                {
                    var tempLogin = dataBase.UsersLogins.FirstOrDefault(x => x.IdUser == Employee.IdUser);
                    dataBase.UsersLogins.Remove(tempLogin);
                    dataBase.SaveChanges();

                    var newLogin = new UsersLogin() { IdUser = Employee.IdUser, Password = EmployeeLogin.Password, UserEmail = EmployeeLogin.UserEmail };
                    dataBase.UsersLogins.Add(newLogin);
                    dataBase.SaveChanges();

                    var temp = dataBase.Users.FirstOrDefault(x=>x.IdUser == Employee.IdUser);
                    temp.Name = Employee.Name;
                    temp.Surname = Employee.Surname;
                    temp.Patronumic = Employee.Patronumic;
                    
                    //tempLogin.UserEmail = EmployeeLogin.UserEmail;
                    //tempLogin.Password = EmployeeLogin.Password;
                    SystemRole currentRole;
                    if (IsAdmin)
                    {
                        currentRole = dataBase.SystemRoles.FirstOrDefault(x => x.RoleName == "");
                        UsersWithRole newRole = new UsersWithRole() { IdRole = currentRole.IdRole, IdUser = Employee.IdUser };
                        List<UsersWithRole> allRoles = dataBase.UsersWithRoles.Include(x=>x.IdRoleNavigation).Where(x => x.IdUser == Employee.IdUser).ToList();
                        bool isConsist = false;
                        foreach (var x in allRoles)
                        {
                            if (x.IdRoleNavigation.RoleName == "") isConsist = true;
                        }
                        if (!isConsist) dataBase.UsersWithRoles.Add(newRole);
                    }
                    else
                    {
                        UsersWithRole? data = dataBase.UsersWithRoles.Include(x=>x.IdRoleNavigation).FirstOrDefault(x => x.IdUser == Employee.IdUser && x.IdRoleNavigation.RoleName == "");
                        if (data != null)
                        {
                            dataBase.UsersWithRoles.Remove(data);
                            dataBase.SaveChanges();
                        }
                    }
                    if (IsTutor)
                    {
                        currentRole = dataBase.SystemRoles.FirstOrDefault(x => x.RoleName == "  ");
                        UsersWithRole newRole = new UsersWithRole() { IdRole = currentRole.IdRole, IdUser = Employee.IdUser };
                        List<UsersWithRole> allRoles = dataBase.UsersWithRoles.Include(x => x.IdRoleNavigation).Where(x => x.IdUser == Employee.IdUser).ToList();
                        bool isConsist = false;
                        foreach (var x in allRoles)
                        {
                            if (x.IdRoleNavigation.RoleName == "  ") isConsist = true;
                        }
                        if (!isConsist) dataBase.UsersWithRoles.Add(newRole);
                    }
                    else
                    {
                        UsersWithRole? data = dataBase.UsersWithRoles.Include(x => x.IdRoleNavigation).FirstOrDefault(x => x.IdUser == Employee.IdUser && x.IdRoleNavigation.RoleName == "  ");
                        if (data != null)
                        {
                            dataBase.UsersWithRoles.Remove(data);
                            dataBase.SaveChanges();
                        }
                    }
                }
                dataBase.SaveChanges();
            }
        }
        public void Delete()
        {
            if (isNotNew)
            {
                dataBase.Users.Remove(Employee);
                dataBase.SaveChanges();
                GoBack();
            }
        }
        public void GoBack()
        {
            globalsData.GlobalUserControl = new AllEmployees(user, ref globalsData);
        }
    }
}