using System;
using System.Collections.Generic;
using System.Linq;
using AvaloniaApplication4.AdditionalModels;
using AvaloniaApplication4.Models;
using AvaloniaApplication4.Views.ActionPages;
using ReactiveUI;

namespace AvaloniaApplication4.ViewModels
{
	public class EditAndAddProgramTemplateViewModel : ViewModelBase
	{
        GlobalsData globalsData;
        User? user;
        ProgramTemplate programTemplate;

        bool isNotNew = false;

        public EditAndAddProgramTemplateViewModel(GlobalsData globalsData, User? user)
        {
            this.globalsData = globalsData;
            this.user = user;
            programTemplate = new ProgramTemplate();
        }

        public EditAndAddProgramTemplateViewModel(GlobalsData globalsData, User? user, ProgramTemplate programTemplate) : this(globalsData, user)
        {
            this.programTemplate = programTemplate;
            isNotNew = true;
        }

        public ProgramTemplate ProgramTemplate { get => programTemplate; set => programTemplate = value; }
        public bool IsNotNew { get => isNotNew; set => isNotNew = value; }

        public void Save()
        {
            if (ProgramTemplate.CodeProgram != string.Empty && ProgramTemplate.NameProgram != string.Empty)
            {
                if (!isNotNew)
                {
                    dataBase.ProgramTemplates.Add(ProgramTemplate);
                }
                else
                {
                    var obj = dataBase.ProgramTemplates.FirstOrDefault(x => x.IdProgramTemplate == ProgramTemplate.IdProgramTemplate);
                    if (obj != null)
                    {
                        obj.NameProgram = ProgramTemplate.NameProgram;
                        obj.CodeProgram = ProgramTemplate.CodeProgram;
                    }
                }
                dataBase.SaveChanges();
            }
        }
        public void Delete()
        {
            if (isNotNew)
            {
                var obj = dataBase.ProgramTemplates.FirstOrDefault(x => x.IdProgramTemplate == ProgramTemplate.IdProgramTemplate);
                if (obj != null)
                {
                    dataBase.ProgramTemplates.Remove(obj);
                    dataBase.SaveChanges();
                    GoBack();
                }
            }
        }
        public void GoBack()
        {
            globalsData.GlobalUserControl = new AllSubjectsModulesAndProgramTemplates(user, ref globalsData);
        }
    }
}