using System;
using System.Collections.Generic;
using System.Linq;
using AvaloniaApplication4.AdditionalModels;
using AvaloniaApplication4.Models;
using AvaloniaApplication4.Views.ActionPages;
using ReactiveUI;

namespace AvaloniaApplication4.ViewModels
{
	public class EditAndAddSubjectViewModel : ViewModelBase
	{
        GlobalsData globalsData;
        User? user;
        Subject subject;

        bool isNotNew = false;

        TrainingStandart trainingStandart;
        CodeAcademicSubject code;
        List<TrainingStandart> trainingStandartList;
        List<CodeAcademicSubject> codeAcademicSubjects;

        public EditAndAddSubjectViewModel(GlobalsData globalsData, User? user)
        {
            this.globalsData = globalsData;
            this.user = user;
            subject = new Subject();
            trainingStandartList = dataBase.TrainingStandarts.ToList();
            codeAcademicSubjects = dataBase.CodeAcademicSubjects.ToList();
            trainingStandart = trainingStandartList.First();
            code = codeAcademicSubjects.First();
        }

        public EditAndAddSubjectViewModel(GlobalsData globalsData, User? user, Subject subject) : this(globalsData, user)
        {
            this.subject = subject;
            isNotNew = true;
            trainingStandart = trainingStandartList.FirstOrDefault(x=>x.IdTrainingStandart == this.subject.IdTrainingStandarts);
            code = codeAcademicSubjects.FirstOrDefault(x=>x.IdCodeAcademicSubjects == this.subject.IdCodeAcademicSubject);
        }

        public Subject Subject { get => subject; set => subject = value; }
        public bool IsNotNew { get => isNotNew; set => isNotNew = value; }
        public TrainingStandart TrainingStandart
        {
            get { return trainingStandart; }
            set
            {
                trainingStandart = value;
                Subject.IdTrainingStandarts = trainingStandart.IdTrainingStandart;
            }
        }
        public CodeAcademicSubject Code
        {
            get { return code; }
            set
            {
                code = value;
                Subject.IdCodeAcademicSubject = code.IdCodeAcademicSubjects;
            }
        }
        public List<TrainingStandart> TrainingStandartList { get => trainingStandartList; set => trainingStandartList = value; }
        public List<CodeAcademicSubject> CodeAcademicSubjects { get => codeAcademicSubjects; set => codeAcademicSubjects = value; }

        public void Save()
        {
            if (Subject.NameSubject != string.Empty)
            {
                if (!isNotNew)
                {
                    Subject.IdCodeAcademicSubject = Code.IdCodeAcademicSubjects;
                    Subject.IdTrainingStandarts = TrainingStandart.IdTrainingStandart;
                    dataBase.Subjects.Add(Subject);
                }
                else
                {
                    var obj = dataBase.Subjects.FirstOrDefault(x => x.IdSubject == Subject.IdSubject);
                    if (obj != null)
                    {
                        obj.NameSubject = Subject.NameSubject;
                        obj.IdCodeAcademicSubject = Code.IdCodeAcademicSubjects;
                        obj.IdTrainingStandarts = TrainingStandart.IdTrainingStandart;
                    }
                }
                dataBase.SaveChanges();
            }
        }
        public void Delete()
        {
            if (isNotNew)
            {
                var obj = dataBase.Subjects.FirstOrDefault(x => x.IdSubject == Subject.IdSubject);
                if (obj != null)
                {
                    dataBase.Subjects.Remove(obj);
                    dataBase.SaveChanges();
                    GoBack();
                }
            }
        }
        public void GoBack()
        {
            globalsData.GlobalUserControl = new AllSubjectsModulesAndProgramTemplates(user, ref globalsData);
        }
    }
}