using System;
using System.Collections.Generic;
using System.Linq;
using AvaloniaApplication4.AdditionalModels;
using AvaloniaApplication4.Models;
using AvaloniaApplication4.Views.StudyLists;
using Microsoft.EntityFrameworkCore;
using ReactiveUI;
using Tmds.DBus.Protocol;

namespace AvaloniaApplication4.ViewModels
{
	public class MySubjectsViewModel : ViewModelBase
	{
        GlobalsData globalsData;
        User? user;
        List<ProgramsWithSubject> subjects = new List<ProgramsWithSubject>();
        public MySubjectsViewModel(User? user, GlobalsData globalsData)
        {
            this.globalsData = globalsData;
            this.user = user;
            Subjects = dataBase.ProgramsWithSubjects
                .Include(x => x.IdSubjectNavigation)
                .Include(x => x.IdTeacherNavigation)
                .Include(x => x.IdRunningProgramNavigation)
                .Include(x => x.IdRunningProgramNavigation.IdProgramTemplateNavigation)
                .ToList();
            Subjects = Subjects.Where(x=>x.IdTeacher == user.IdUser).ToList();
        }

        public List<ProgramsWithSubject> Subjects
        {
            get { return subjects; }
            set
            {
                if (subjects == value)
                    return;

                subjects = value;
                OnPropertyChanged("Subjects");
            }
        }
        public void GetCredit(int id)
        {
            var currentProgramAndSubject = dataBase.ProgramsWithSubjects
                .Include(x=>x.IdWayNavigation).FirstOrDefault(x=>x.Id == id);
            if (currentProgramAndSubject != null)
            {
                if (currentProgramAndSubject.IdWayNavigation.Name == "")
                {
                    globalsData.GlobalUserControl = new DiffCredit(user, ref globalsData, currentProgramAndSubject, 0);
                }
                else if (currentProgramAndSubject.IdWayNavigation.Name == "")
                {

                }
            }
        }
    }
}