using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.EntityFrameworkCore;
using ReactiveUI;
using static AvaloniaApplication4.ViewModels.BindingElement;

namespace AvaloniaApplication4.ViewModels.StudyListsViewModels
{
    public class PDFPrintDiffCreditViewModel : ViewModelBase
    {
        string nameSubject;
        string nameProgram;
        string fioTeacher;
        Models.ProgramsWithSubject subject;

        List<BindingElement> allGradesBinding;
        List<Statistic> statistics;
        List<GradeBinding> grades;
        List<StatisticBinding> statisticBindings;
        public PDFPrintDiffCreditViewModel(List<BindingElement> allGradesBinding, List<Statistic> statistics, Models.ProgramsWithSubject subject)
        {
            this.subject = subject;
            nameSubject = subject.IdSubjectNavigation.NameSubject;
            nameProgram = subject.IdRunningProgramNavigation.IdProgramTemplateNavigation.CodeProgram + " " + subject.IdRunningProgramNavigation.IdProgramTemplateNavigation.NameProgram;
            fioTeacher = subject.IdTeacherNavigation.Surname + " " + subject.IdTeacherNavigation.Name[0].ToString() + "." + subject.IdTeacherNavigation.Patronumic[0].ToString();
            this.statistics = statistics;
            this.allGradesBinding = allGradesBinding.OrderBy(x=>x.Grade.IdStudentNavigation.Surname).ToList();
            grades = new List<GradeBinding>();
            int counter = 1;
            foreach (var x in  allGradesBinding)
            {
                grades.Add(new GradeBinding() { Number = counter, Fio = x.Grade.IdStudentNavigation.Surname + " " + x.Grade.IdStudentNavigation.Name + " " + x.Grade.IdStudentNavigation.Patronumic, Grage = x.AllGradesInBase[x.IdGradle].Name });
                counter++;
            }
            grades = grades.OrderBy(x=>x.Number).ToList();
            var currentObject = statistics.First();
            statisticBindings = new List<StatisticBinding>()
            {
                new StatisticBinding() { Name = " ", Value = currentObject.CountStudents.ToString()},
                new StatisticBinding() { Name = "", Value = currentObject.CountAtt.ToString()},
                new StatisticBinding() { Name = " 5", Value = currentObject.CountGrade5.ToString()},
                new StatisticBinding() { Name = " 4", Value = currentObject.CountGrade4.ToString()},
                new StatisticBinding() { Name = " 3", Value = currentObject.CountGrade3.ToString()},
                new StatisticBinding() { Name = " 2*", Value = currentObject.CountGrade2.ToString()},
                new StatisticBinding() { Name = " *", Value = currentObject.CountNotAtt.ToString()},
                new StatisticBinding() { Name = "*", Value = currentObject.CountNotCome.ToString()}
            };
        }

        public List<GradeBinding> Grades { get => grades; set => grades = value; }
        public List<StatisticBinding> StatisticBindings { get => statisticBindings; set => statisticBindings = value; }
        public string NameSubject { get => nameSubject; set => nameSubject = value; }
        public string NameProgram { get => nameProgram; set => nameProgram = value; }
        public string FioTeacher { get => fioTeacher; set => fioTeacher = value; }

        public class GradeBinding
        {
            int? number;
            string fio;
            string? grage;

            public int? Number { get => number; set => number = value; }
            public string Fio { get => fio; set => fio = value; }
            public string? Grage { get => grage; set => grage = value; }
        }
        public class StatisticBinding
        {
            string name;
            string value;
            public string Value { get => value; set => this.value = value; }
            public string Name { get => name; set => name = value; }
        }
    }
}