﻿using Avalonia;
using Avalonia.Controls;
using Avalonia.Controls.Shapes;
using Avalonia.Platform;
using Avalonia.Platform.Storage;
using AvaloniaApplication4.Models;
using AvaloniaApplication4.Views;
using AvaloniaApplication4.Views.StudyLists;
using AvaloniaUI.PrintToPDF;
using Microsoft.EntityFrameworkCore;
using ReactiveUI;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.IO;
using System.Linq;
using System.Threading.Tasks;
using Tmds.DBus.Protocol;

namespace AvaloniaApplication4.ViewModels
{
    public class ViewModelBase : INotifyPropertyChanged
    {
        private UserControl mainUserControl = new StartPageLogin();
        
        //public TestDataBaseCheskinaContext dataBase = new TestDataBaseCheskinaContext();
        public TestDataBaseCheskinaContext dataBase = new TestDataBaseCheskinaContext();
        private List<StudyResults> studyResults = new List<StudyResults>() { new StudyResults(0, "Не выбрано"), new StudyResults(1, "5"), new StudyResults(2, "4"), new StudyResults(3, "3"), new StudyResults(4, "2"), new StudyResults(5, "н/а"), new StudyResults(6, "н/я") };
        public class StudyResults: INotifyPropertyChanged
        {
            int idResult;
            string nameResult;
            public event PropertyChangedEventHandler PropertyChanged;
            protected virtual void OnPropertyChanged(string propertyName)
            {
                PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
            }

            public StudyResults(int idResult, string nameResult)
            {
                this.idResult = idResult;
                this.nameResult = nameResult;
            }

            public int IdResult
            {
                get { return idResult; }
                set
                {
                    if (idResult == value)
                        return;

                    idResult = value;
                    OnPropertyChanged("IdResult");
                }
            }
            public string NameResult { get => nameResult; set => nameResult = value; }
        }
        public event PropertyChangedEventHandler PropertyChanged;
        protected virtual void OnPropertyChanged(string propertyName)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
        public UserControl MainUserControl
        {
            get { return mainUserControl; } 
            set
            {
                if (mainUserControl == value)
                    return;

                mainUserControl = value;
                OnPropertyChanged("MainUserControl");
            }
        }

        public List<StudyResults> StudyResultsAll { get => studyResults; set => studyResults = value; }
        private string pathLog = "Logs.txt";
        //возможно нужно не async
        public async void WriteToLog(int idUser, string message)
        {
            var user = dataBase.Users.FirstOrDefault(x=>x.IdUser == idUser);
            var allUserRoles = dataBase.UsersWithRoles.Include(x=>x.IdRoleNavigation).Where(x=>x.IdUser == user.IdUser).ToList();
            bool status = true;
            foreach (var role in allUserRoles)
            {
                if (role.IdRoleNavigation.RoleName == "Администратор") status = false; break;
            }
            if (status)
            {
                try
                {
                    Log log = new Log() { IdUser = user.IdUser, Description = message, Date = DateOnly.FromDateTime(DateTime.Now) };
                    dataBase.Logs.Add(log);
                    await dataBase.SaveChangesAsync();
                }
                catch { }
            }
        }
        public async void SavePDF(Window window)
        {
            window.Show();
            var provider = window.StorageProvider;
            var options = new FolderPickerOpenOptions { Title = "Выберите папку", AllowMultiple = false };
            var dialog = await provider.OpenFolderPickerAsync(options);
            //нужно сделать так чтобы имя файла пользователь сам писал
            if (dialog.Count > 0)
            {
                var path = dialog.First().Path.LocalPath + "\\test.pdf";
                Print.ToFile(path, window);
            }
            window.Close();
        }
        public List<string> ReadLog()
        {
            List<string> allLog = new List<string>();
            try
            {
                StreamReader f = new StreamReader(pathLog);
                while (!f.EndOfStream)
                {
                    string s = f.ReadLine();
                    allLog.Add(s);
                }
                f.Close();
            }
            catch { }
            return allLog;
        }
    }
}